# install.packages("english")
# install.packages("scales")
# install.packages("tidyverse")
# install.packages("ggplot2")
# install.packages("xtable")
# install.packages("tidyverse")
# install.packages("Hmisc")
# install.packages("corrplot")
# install.packages("nnet")
# install.packages("reshape2")
# install.packages("foreign")
# install.packages("viridis")
# install.packages("hrbrthemes")
# install.packages("gridExtra")
# install.packages("sjPlot")
# install.packages("stargazer")
# install.packages("writexl")
#install.packages("readxl")

require(gridExtra)
require(foreign);require(lmtest);require(sandwich);require(oddsratio)
require(dplyr);require(effsize);require(car);require(pscl);require(pastecs)
require(MASS);require(nnet);library(effsize);library(epiR);library(ggplot2);
require(gridExtra)
if(!require(rcompanion)){install.packages("rcompanion")}
if(!require(vcd)){install.packages("vcd")}
if(!require(psych)){install.packages("psych")}
if(!require(DescTools)){install.packages("DescTools")}
if(!require(epitools)){install.packages("epitools")}
library(rcompanion)

library(rcompanion)
library("writexl")
library(english)
library(reshape)
library(ggpubr)
library(scales)
library(tidyr)
library(xtable)
library(tidyverse)
library(Hmisc)
library(corrplot)
library(haven)
library(viridis)
library(hrbrthemes)
library("readxl")
library(dplyr)

# the following only works with RStudio! Sets working directory to source file
# location
setwd(dirname(rstudioapi::getActiveDocumentContext()$path))
# if you're using R standard, please run the following instead:
# setwd(getSrcDirectory()[1])

# if you want to automatically save the latex commands and figures, 
# uncomment the following lines to create the folders 
#dir.create("../results/figures/", showWarnings = FALSE)
#dir.create("../results/latex/", showWarnings = FALSE)

#r eads the parsed logs into the dataset
results <- read_csv(
   # TODO Adjust path
   file = "../results/parsed_logs.csv",
   col_names = TRUE)

# Rename Column and Count Distribution
setNames(as.data.frame(table(results$checklistType)), c("treatment","n"))

# Our dataset has 150 valid participants
if(count(results) != 150){
   warning("wrong number of participants")   
}

# we calculate the duration of the review
results = results %>% mutate(duration_CR = as.double(difftime(results$cr1end,results$cr1Start,units = "mins")))

# We now look at the outliers in terms of time
 boxplot(results$duration_CR)
 summary(results$duration_CR)
 
# For further analysis of the outliers, uncomment the following lines:
# more40 =  results %>% filter(results$duration_CR > 40)
# less5 =  results %>% filter(results$duration_CR < 5)
# write_xlsx(more40, "more40.xlsx")
# write_xlsx(less5, "less5.xlsx")

## For convenience, we report here the question associated to each var
#  the following questions are from the file '../tool/templates/survey.html'

# [0=No interruption time,1=1-2 minutes,2=up to 5 minutes,3=up to 10 minutes,4=more than 10 minutes]
# question_interruption_time  How long have you been interrupted during the execution of the review?

# [0=No interruption time,1=1-2 minutes,2=up to 5 minutes,3=up to 10 minutes,4=more than 10 minutes]
# question_interruption_time2nd  How long have you been interrupted during the execution of the review?

# [0=no,1=yes]
# familiar           I am familiar with the concept of software vulnerabilities
# incidents          I have experience with security incidents
# courses            I have participated in security courses and/or training
# practice        I use what I have learned in practice

# [1=Never,2=Rarely,3=Occasionally,4=A moderate amount,5=A great deal,6=I don't know,7=Not Applicable]
# updated            I keep myself up to date with security information
# responsibility     It is part of my job responsibility to look for vulnerabilities (the name of this variable is switched with `designing` in the logs, but corrected by the parser)
# designing          I actively consider vulnerabilities when designing software     (the name of this variable is switched with `responsibility` in the logs, but corrected by the parser)
# coding             I actively consider vulnerabilities when coding
# reviewing          I actively look for vulnerabilities when reviewing

# [1=Never,2=Rarely,3=Occasionally,4=A moderate amount,5=A great deal,6=I don't know,7=Not Applicable]
# How often did the following detection approaches help you finding vulnerabilities
# tools              Static analysis tools
# dynamic            Dynamic tools, such as
# manual             Manual analysis

# [1=Strongly disagree,2=Disagree,3=Neutral,4=Agree,5=Strongly agree,6=I don't know,7=Not Applicable]
# Considering the project you work on the most, please rate your agreement with the following statements.
# aware              Project developers are aware of potential security issues
# expertise          Project developers have expertise in software security
# availability       Detection tools are used to find software vulnerabilities
# cr                 Code review is used to find software vulnerabilities
# third-lib          Third-party libraries are checked for security issues
# documentation      Security documentation and training are available
# time               Enough time is available to consider security aspects

# [1=Not at all effective,2=Slightly effective,3=Somewhat effective,4=Very effective,5=Extremely effective,6=I don't know,7=Not Applicable]
# Considering the project you work on the most, rate how effective, in your opinion, the following measures would be in reducing the number of vulnerabilities:
# increase_aware     Increasing awareness of potential security issues
# qsec_adopt_cr      Increasing the use of code review to find software vulnerabilities
# bettertests        Writing more and better tests
# betterdocs         Having more and better security documentation and training
# sec_libs           Reinforcing the security check of third-party libraries
# secperson          Having people responsible for security in the project/company
# toolsiden          Increasing the use of tools to identify security bugs
# pastvuln           Learning from past vulnerabilities that affected the project
# more_time          more_time

#  the following questions are from the file '../tool/templates/dem_questions.html'

# text area
# question_gender    What is your gender?

# [0=High School but did not graduate,1=High School graduate or GED,2=Some college or 2-year degree,
#  3=Bachelor in CS (Computer Science),4=Bachelor in STEM (Science, Technology, Engineering and Mathematics),
#  5=Bachelor in a different area than CS or STEM,6=Master in CS,7=Master in STEM,8=Master in a different area than CS or STEM,
#  9=PhD or higher academic title in CS,10=PhD or higher academic title in STEM,
#  11=PhD or higher academic title in a different area than CS or STEM]
# question_1         What is your highest achieved level of education?

# [checkbox; 0=Student,1=Intern,2=Part-time position,3=Full-time position,4=Unemployed]
# question_demo4     What's your current employment status?
# [0=yes,1=no]
# question_dem6       Are you currently enrolled in a degree-granting program?
#
# [0=Software developer,1=Penetration tester,2=Bug bounty hunter,3=Software architect,
#  4=IT operations,5=Project manager,6=Researcher / Professor,7=PhD student]
# question_demo5      What is your current position related to?

# [0=yes,1=no]
# question_dem8      Do you contribute to open-source software systems as one of your main programming activities?

# [1=None,2=1 year or less,3=2 years,4=3-5 years,5=6-10 years,6=11 years or more]
# Please specify for how many years you have performed the following activities
#
# professional       Developed software in a professional setting (e.g., as employee of an IT-company or Open-Source contributor)
# java               Programmed in Java (also not professionally)
# year-cr            Reviewed code
# year-db            Worked with web applications
# year-sql           Worked with applications using databases

# [1=Not at all,2=About once,3=About once a month,4=About once a week,5=Daily or more often]
# Please specify how often you have performed the following activities in the last year
#
# often-design       Designed code
# often-programming  Developed code
# often-cr           Reviewed code

results$updated[results$updated == "7"] <- 1 #we replace the not applicable answer for never
results$responsibility[results$responsibility == "7"] <- 1  #we replace the not applicable answer for never
results$designing[results$designing == "7"] <- 1  #we replace the not applicable answer for never
results$reviewing[results$reviewing == "7"] <- 1  #we replace the not applicable answer for never
results$availability[results$availability == "7"] <- 1 #we replace the not applicable answer for strongly disagree
results$availability[results$availability == "6"] <- 3 #we replace the don't know answer for neutral
results$cr[results$cr == "7" | results$cr == "6"] <- 3 #we replace the not applicable/don't know answer for neutral
results$`third-lib`[results$`third-lib` == "7" | results$`third-lib` == "6"] <- 3 #we replace the not applicable/don't know answer for neutral 
results$documentation[results$documentation == "7" | results$documentation == "6"] <- 3 #we replace the not applicable/don't know answer for neutral 
results$time[results$time == "7" | results$time == "6"] <- 3 #we replace the not applicable/don't know answer for neutral 
results$checkpref[results$checkpref == "7" | results$checkpref == "6"] <- 3 #we replace the not applicable/don't know answer for neutral
results$checkeff[results$checkeff == "7" | results$checkeff == "6"] <- 3 #we replace the not applicable/don't know answer for neutral
results$checkhelps[results$checkhelps == "7" | results$checkhelps == "6"] <- 3 #we replace the not applicable/don't know answer for neutral
results$checkexp[results$checkexp == "7"] <- 1 #we replace the not applicable answer for never
results$availability[results$checkused == "7"] <- 1 #we replace the not applicable answer for strongly disagree
results$availability[results$checkused == "6"] <- 3 #we replace the don't know answer for neutral
results$practice[is.na(results$practice)] <- 0

setNames(as.data.frame(table(results$checklistType)), c("treatment","n"))

# We add a new column called vuln_found which can take the following values
# 0=Neither SDE nor CKV was found
# 1=SDE was found
# 2=CKV was found
# 3=Both SDE and CKV were found
results<-results %>% mutate(vuln_found = case_when(
   VALIDATION_sde==1 & VALIDATION_ckv==1 ~ "none",
   VALIDATION_sde==0 & VALIDATION_ckv==1 ~ "sde",
   VALIDATION_sde==1 & VALIDATION_ckv==0 ~ "ckv",
   VALIDATION_sde==0 & VALIDATION_ckv==0 ~ "both"
))

########################################################################
############################ TABLE 2 ###################################
NF <- results %>% filter(results$checklistType == "NF")
NC <- results %>% filter(results$checklistType == "NC")
SC <- results %>% filter(results$checklistType == "SC")
LC <- results %>% filter(results$checklistType == "LC")

total.participants <- count(results)
total.NC <- count(results %>% filter(results$checklistType == "NC"))
total.NF <- count(results %>% filter(results$checklistType == "NF"))
total.SC <- count(results %>% filter(results$checklistType == "SC"))
total.LC <- count(results %>% filter(results$checklistType == "LC"))

total.NF.found.sde <- count(NF %>% filter(VALIDATION_sde == 0))
total.NF.missed.sde <- count(NF %>% filter(VALIDATION_sde == 1))

per.NF.found.sde <- percent(unlist(total.NF.found.sde)/unlist(total.NF))
per.NF.missed.sde <- percent(unlist(total.NF.missed.sde)/unlist(total.NF))

total.NC.found.sde <- count(NC %>% filter(VALIDATION_sde == 0))
total.NC.missed.sde <- count(NC %>% filter(VALIDATION_sde == 1))

per.NC.found.sde <- percent(unlist(total.NC.found.sde)/unlist(total.NC))
per.NC.missed.sde <- percent(unlist(total.NC.missed.sde)/unlist(total.NC))

total.LC.found.sde <- count(LC %>% filter(VALIDATION_sde == 0))
total.LC.missed.sde <- count(LC %>% filter(VALIDATION_sde == 1))

per.LC.found.sde <- percent(unlist(total.LC.found.sde)/unlist(total.LC))
per.LC.missed.sde <- percent(unlist(total.LC.missed.sde)/unlist(total.LC))

total.SC.found.sde <- count(SC %>% filter(VALIDATION_sde == 0))
total.SC.missed.sde <- count(SC %>% filter(VALIDATION_sde == 1))

per.SC.found.sde <- percent(unlist(total.SC.found.sde)/unlist(total.SC))
per.SC.missed.sde <- percent(unlist(total.SC.missed.sde)/unlist(total.SC))

total.NF.found.ckv <- count(NF %>% filter(VALIDATION_ckv == 0))
total.NF.missed.ckv <- count(NF %>% filter(VALIDATION_ckv == 1))

per.NF.found.ckv <- percent(unlist(total.NF.found.ckv)/unlist(total.NF))
per.NF.missed.ckv <- percent(unlist(total.NF.missed.ckv)/unlist(total.NF))

total.NC.found.ckv <- count(NC %>% filter(VALIDATION_ckv == 0))
total.NC.missed.ckv <- count(NC %>% filter(VALIDATION_ckv == 1))

per.NC.found.ckv <- percent(unlist(total.NC.found.ckv)/unlist(total.NC))
per.NC.missed.ckv <- percent(unlist(total.NC.missed.ckv)/unlist(total.NC))

total.LC.found.ckv <- count(LC %>% filter(VALIDATION_ckv == 0))
total.LC.missed.ckv <- count(LC %>% filter(VALIDATION_ckv == 1))

per.LC.found.ckv <- percent(unlist(total.LC.found.ckv)/unlist(total.LC))
per.LC.missed.ckv <- percent(unlist(total.LC.missed.ckv)/unlist(total.LC))

total.SC.found.ckv <- count(SC %>% filter(VALIDATION_ckv == 0))
total.SC.missed.ckv <- count(SC %>% filter(VALIDATION_ckv == 1))

per.SC.found.ckv <- percent(unlist(total.SC.found.ckv)/unlist(total.SC))
per.SC.missed.ckv <- percent(unlist(total.SC.missed.ckv)/unlist(total.SC))

tab <- matrix(c(sprintf("%s (%s)", total.NF.found.sde, per.NF.found.sde),
                sprintf("%s (%s)", total.NF.missed.sde, per.NF.missed.sde),
                sprintf("%s (%s)", total.NF.found.ckv, per.NF.found.ckv),
                sprintf("%s (%s)", total.NF.missed.ckv, per.NF.missed.ckv),
                sprintf("%s (%s)", total.NC.found.sde, per.NC.found.sde),
                sprintf("%s (%s)", total.NC.missed.sde, per.NC.missed.sde),
                sprintf("%s (%s)", total.NC.found.ckv, per.NC.found.ckv),
                sprintf("%s (%s)", total.NC.missed.ckv, per.NC.missed.ckv),
                sprintf("%s (%s)", total.LC.found.sde, per.LC.found.sde),
                sprintf("%s (%s)", total.LC.missed.sde, per.LC.missed.sde),
                sprintf("%s (%s)", total.LC.found.ckv, per.LC.found.ckv),
                sprintf("%s (%s)", total.LC.missed.ckv, per.LC.missed.ckv),
                sprintf("%s (%s)", total.SC.found.sde, per.NC.found.sde),
                sprintf("%s (%s)", total.SC.missed.sde, per.NC.missed.sde),
                sprintf("%s (%s)", total.SC.found.ckv, per.NC.found.ckv),
                sprintf("%s (%s)", total.SC.missed.ckv, per.NC.missed.ckv)),
              ncol=8)

rownames(tab) <- c('Found', 'Not Found')
#NF, NC, LC, SC
colnames(tab) <- c('SDE', 'CKV', 'SDE', 'CKV', 'SDE', 'CKV', 'SDE', 'CKV')

total.sde.found <- count(results %>% filter(results$VALIDATION_sde==0))
total.ckv.found <- count(results %>% filter(results$VALIDATION_ckv==0))
total.sde.missed <- count(results %>% filter(results$VALIDATION_sde==1))
total.ckv.missed <- count(results %>% filter(results$VALIDATION_ckv==1))

per.sde.found <- percent(unlist(total.sde.found  / total.participants))
per.ckv.found <- percent(unlist(total.ckv.found  / total.participants))
per.sde.missed <- percent(unlist(total.sde.missed  / total.participants))
per.ckv.missed <- percent(unlist(total.ckv.missed  / total.participants))

total.found.at.least.one <- count(results %>% filter(results$VALIDATION_sde==0 | results$VALIDATION_ckv==0))

transposed_tab <- as.data.frame(t(tab))

transposed_tab[nrow(transposed_tab) + 1,] = c(sprintf("%s (%s)", total.sde.found, per.sde.found),
                                              sprintf("%s (%s)", total.sde.missed, per.sde.missed))
transposed_tab[nrow(transposed_tab) + 1,] = c(sprintf("%s (%s)", total.ckv.found, per.ckv.found),
                                              sprintf("%s (%s)", total.ckv.missed, per.ckv.missed))

row.names(transposed_tab)[9] <- "total.sde"
row.names(transposed_tab)[10] <- "total.ckv"

transposed_tab

# We used the following function to automatically generate Table 2
save_tab2_latex <- function(){
   tab_latex <- xtable(transposed_tab)
   tab_latex <- print.xtable(tab_latex)
   
   tab_latex
   
   tab_latex <- gsub(".00", "", tab_latex)
   tab_latex <- gsub("\\{rll\\}\n  \\\\hline", "\\{lcrr\\}", tab_latex)
   
   tab_latex <- gsub("& Found & Not Found ", "\\\\multicolumn\\{2\\}\\{l\\}\\{\\\\textit\\{Review Group\\}\\} & \\\\multicolumn\\{1\\}\\{c\\}\\{\\\\cellcolor[HTML]\\{dadaeb\\}\\\\textbf\\{Found\\}\\} & \\\\multicolumn\\{1\\}\\{c\\}\\{\\\\cellcolor[HTML]\\{dadaeb\\}\\\\textbf\\{Not Found\\}\\}", tab_latex)
   
   tab_latex <- gsub("\\\\centering", "\\\\centering \n \\\\caption{Results of the code review experiment.} \n \\\\label{tab:rq1-results}", tab_latex)
   # tab_latex <- gsub("\\\\end\\{tabular\\}", "\\\\end\\{tabular\\} \n}", tab_latex)
   
   
   tab_latex <- gsub("SDE &", "\\\\multicolumn\\{1\\}\\{r\\}\\{\\\\multirow\\{2\\}\\{*\\}\\{\\\\nfShort\\}\\} & SDE &", tab_latex)
   tab_latex <- gsub("SDE.1", "\\\\hline \n \\\\multicolumn\\{1\\}\\{r\\}\\{\\\\multirow\\{2\\}\\{*\\}\\{\\\\ncShort\\}\\} & SDE", tab_latex)
   tab_latex <- gsub("SDE.2", "\\\\hline \n \\\\multicolumn\\{1\\}\\{r\\}\\{\\\\multirow\\{2\\}\\{*\\}\\{\\\\lcShort\\}\\} & SDE", tab_latex)
   tab_latex <- gsub("SDE.3", "\\\\hline \n \\\\multicolumn\\{1\\}\\{r\\}\\{\\\\multirow\\{2\\}\\{*\\}\\{\\\\scShort\\}\\} & SDE", tab_latex)
   
   tab_latex <- gsub("CKV &", "\\\\multicolumn\\{1\\}\\{l\\}\\{\\} & CKV &", tab_latex)
   tab_latex <- gsub("CKV.1", "\\\\multicolumn\\{1\\}\\{l\\}\\{\\} & CKV", tab_latex)
   tab_latex <- gsub("CKV.2", "\\\\multicolumn\\{1\\}\\{l\\}\\{\\} & CKV", tab_latex)
   tab_latex <- gsub("CKV.3", "\\\\multicolumn\\{1\\}\\{l\\}\\{\\} & CKV", tab_latex)
   
   tab_latex <- gsub("total.sde", "\\\\bottomrule \n \\\\multicolumn\\{1\\}\\{l\\}\\{\\\\multirow\\{2\\}\\{*\\}\\{\\\\textbf\\{Total\\}\\}\\} & SDE ", tab_latex)
   tab_latex <- gsub("total.ckv", "\\\\multicolumn\\{1\\}\\{l\\}\\{\\} & CKV", tab_latex)
   
   tab_latex <- gsub("\\\\hline\n\\\\end\\{tabular\\}", "\\\\end\\{tabular\\}", tab_latex)
   
   tab_latex <- gsub("SDE", "\\\\SDEshortNotBold", tab_latex)
   tab_latex <- gsub("CKV", "\\\\CKVshortNotBold", tab_latex)
   
   tab_latex
   
   fileConn<-file("../../../paper/tabs/tab-rq1.tex", "w")
   
   write(tab_latex, file=fileConn, append=TRUE,sep = "\n")
   
   close(fileConn)
}

#save_tab2_latex

#########################################################################
##################### Comparing Groups ##################################

results %>% group_by(question_demo5) %>% dplyr::summarize(n())

jobs <- results %>%
   group_by(question_demo5, checklistType) %>%
   dplyr::summarize(n())

jobs <- spread(jobs, checklistType, `n()`)

jobs$question_demo5[jobs$question_demo5 == 0] <- "Software developer"
jobs$question_demo5[jobs$question_demo5 == 1] <- "Penetration tester"
jobs$question_demo5[jobs$question_demo5 == 2] <- "Bug bounty hunter"
jobs$question_demo5[jobs$question_demo5 == 3] <- "Software architect"
jobs$question_demo5[jobs$question_demo5 == 4] <- "IT operations"
jobs$question_demo5[jobs$question_demo5 == 5] <- "Project manager"
jobs$question_demo5[jobs$question_demo5 == 6] <- "Researcher/Professor"
jobs$question_demo5[jobs$question_demo5 == 7] <- "PhD student"
jobs$question_demo5[jobs$question_demo5 == 8] <- "Other"

boxplot(results$professional~results$checklistType, data=results)

# We want to know if there is any significant difference between the average of 
# professional programming experience
# Compute the analysis of variance
res.aov <- aov(professional ~ checklistType, data = results)
# Summary of the analysis
summary(res.aov)

# We can compute Tukey HSD (Tukey Honest Significant Differences, 
# R function: TukeyHSD()) for performing multiple pairwise-comparison
# between the means of groups.
#The function TukeyHD() takes the fitted ANOVA as an argument.
TukeyHSD(res.aov)

#highest degree
res.aov <- aov(question_1 ~ checklistType, data = results)
summary(res.aov)
TukeyHSD(res.aov)

#current employment status
test <- results
test$question_demo4[test$question_demo4 == "0 + 2"] <- "2"
test$question_demo4[test$question_demo4 == "0 + 3"] <- "3"
test$question_demo4[test$question_demo4 == "0 + 4"] <- "4"
test$question_demo4[test$question_demo4 == "2 + 3"] <- "3"

res.aov <- aov(question_demo4 ~ checklistType, data = test)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#highest degree
res.aov <- aov(question_1 ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#java
res.aov <- aov(java ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#years cr
res.aov <- aov(`year-cr` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#years db
res.aov <- aov(`year-db` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#years sql
res.aov <- aov(`year-sql` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#often design
res.aov <- aov(`often-design` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#often programming
res.aov <- aov(`often-programming` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

#often cr
res.aov <- aov(`often-cr` ~ checklistType, data = results)
summary(res.aov)
p <- TukeyHSD(res.aov)
p$checklistType
result<-data.frame(p$checklistType)
p<-result["p.adj"]
round(p.adjust(p$p.adj, method="holm"),3)

######################## STATISTICAL MODEL ##############################
# This is the function to print the statistical model. As explained in the
# paper, we use a logistic regression model.
print_fit <- function(dataset,formula) {
   fitglm <- glm(formula=formula, family=binomial(logit), data=dataset, maxit = 100)
   
   cov.m1 <- vcovHC(fitglm, type = "HC0")
   std.err <- sqrt(diag(cov.m1))
   q.val <- qnorm(0.975)
   r.est <- cbind(
      Estimate = coef(fitglm)
      , "Robust SE" = std.err
      , z = (coef(fitglm)/std.err)
      , "Pr(>|z|) "= 2 * pnorm(abs(coef(fitglm)/std.err), lower.tail = FALSE)
      , LL = coef(fitglm) - q.val  * std.err
      , UL = coef(fitglm) + q.val  * std.err
   )
   print(summary(fitglm))
   print("--------------- VIF, values should be < 10 to be OK")
   print(vif(fitglm))
   print("---------------")
   return(fitglm)
}

# use varclus to check for multicollinearity
# we are very conservative here (also to simplify the model)
# and consider a rather low threshold 0.5 instead of 0.7
print_varclus <- function(dataset,formula) {
   vc = varclus(formula, data=dataset)
   plot(vc)
   threshold <- 0.5
   abline(h=1-threshold, col = "red", lty = 2)
}


#####################################################################
#####################################################################
#####################################################################
####### RQ 1 #######

# What to watch for when building the model
# 1. Exclude variables with high collinearity
# 2. Exclude variables with high number of missing values
# 3. Potentially exclude variables with small variablility

# check for collinearity of variables
# we are very conservative here (also to simplify the model)
# and consider a rather low threshold 0.5 instead of 0.7

################LogReg Model RQ1 SDE#####################
# Create DF that only consists of Checklist/No Checklist (Merge SC and LC)
logregrq1 <- results
logregrq1$checklistType <- relevel(as.factor(logregrq1$checklistType), ref = "NF")
logregrq1$sde <- ifelse(logregrq1$VALIDATION_sde == 0, TRUE, FALSE)
logregrq1$ckv <- ifelse(logregrq1$VALIDATION_ckv == 0, TRUE, FALSE)
logregrq1$checklist <- ifelse(logregrq1$checklistType == "SC" | logregrq1$checklistType == "LC", TRUE, FALSE)

# SDE has a setup of False/True, thus the model evaluates for True (Second var)
formulaRQ1SDE = sde ~
   checklistType +
   ckv +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   professional +
   java +
   `year-cr` +
   `year-db` +
   `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
#itemsSkipped

print_varclus(logregrq1, formulaRQ1SDE)

# this is the new formula after we remove vars that are too correlated
formulaRQ1SDE = sde ~
   checklistType +
   #ckv +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   professional +
   java +
   # `year-cr` +
   # `year-db` +
   # `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
# itemsSkipped

print_varclus(logregrq1, formulaRQ1SDE)

# RQ1: Regression model for the first code review.
modelRQ1<- print_fit(logregrq1, formulaRQ1SDE)

modelRQ1_output <- capture.output(summary(modelRQ1))

# To automatically save the model as a latex table, run the following commands:
# interceptRQ1 <- strsplit(grep("Intercept", modelRQ1_output, value = TRUE), "\\s+")
# 
# modelRQ1_table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ1[[1]][2], "S.E." = interceptRQ1[[1]][3],
#                              "Sig." =interceptRQ1[[1]][6])
# 
# variables <- strsplit(modelRQ1_output, "\n")
# 
# important_variables = FALSE
# 
# modelRQ1_table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ1[[1]][2], "S.E." = interceptRQ1[[1]][3],
#                              "Sig." =interceptRQ1[[1]][6])
# 
# for (vari in variables){
#    if (!is.na(vari[1])){
#       aux <- vari[1]
#       if(grepl("Intercept", aux, fixed=TRUE)){
#          important_variables = TRUE
#       }
#       else if(grepl("---", aux, fixed=TRUE)){
#          important_variables = FALSE
#       }
#       else if(important_variables){
#          aux <- strsplit(aux, "\\s+")
#          if (startsWith(aux[[1]][1], "setexperimentCRtypefiles")){
#             modelRQ1_table <- modelRQ1_table %>% add_row("Variable" = "VulnType", "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3], 
#                                                          "Sig." =aux[[1]][6])
#          }else{
#             modelRQ1_table <- modelRQ1_table %>% add_row("Variable" = aux[[1]][1], "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3], 
#                                                          "Sig." =aux[[1]][6])
#          }
#       }
#    }
# }
# 
updateColumnsOfModel1<- function(dataset){
   dataset$Variable[dataset$Variable == "bug_cr_discovered"] <- "BugFound"
   dataset$Variable[dataset$Variable == "coding"] <- "Coding"
   dataset$Variable[dataset$Variable == "courses"] <- "Courses"
   dataset$Variable[dataset$Variable == "duration_CR1"] <- "DurationReview"
   dataset$Variable[dataset$Variable == "familiar"] <- "Familiarity"
   dataset$Variable[dataset$Variable == "incidents"] <- "Incidents"
   dataset$Variable[dataset$Variable == "manual"] <- "ManualAnalysis"
   dataset$Variable[dataset$Variable == "dynamic"] <- "DynamicAnalysis"
   dataset$Variable[dataset$Variable == "responsibility"] <- "Responsibility"
   dataset$Variable[dataset$Variable == "reviewing"] <- "Reviewing"
   dataset$Variable[dataset$Variable == "tools"] <- "StaticAnalysis"
   dataset$Variable[dataset$Variable == "betterdocs"] <- "BetterDoc"
   dataset$Variable[dataset$Variable == "updated"] <- "KnowledgeUpdate"
   dataset$Variable[dataset$Variable == "\`often-programming\`"] <- "DevFreq"
   dataset$Variable[dataset$Variable == "\`often-cr\`"] <- "CRFreq"
   dataset$Variable[dataset$Variable == "java"] <- "JavaExp"
   dataset$Variable[dataset$Variable == "sld6"] <- "PerReviewing"
   dataset$Variable[dataset$Variable == "professional"] <- "ProfDevExp"
   dataset$Variable[dataset$Variable == "question_interruption_time"] <- "Interruptions"
   dataset$Variable[dataset$Variable == "cr"] <- "CRusage"
   dataset$Variable[dataset$Variable == "availability"] <- "ToolUsage"
   dataset$Variable[dataset$Variable == "time"] <- "EnoughTime"
   dataset$Variable[dataset$Variable == "\`year-db\`"] <- "DBDevExp"
   dataset$Variable[dataset$Variable == "\`third-lib\`"] <- "ThirdPartyLib"
   dataset$Variable[dataset$Variable == "\`often-design\`"] <- "OftenDesign"
   dataset$Variable[dataset$Variable == "question_dem8"] <- "OSSDev"
   dataset$Variable[dataset$Variable == "question_demo5"] <- "Role"
   dataset$Variable[dataset$Variable == "practice"] <- "Practice"
   dataset$Variable[dataset$Variable == "designing"] <- "Designing"
   dataset$Variable[dataset$Variable == "checkexp"] <- "ChecklistExp"
   return(dataset)
}

# To automatically save the model as a latex table, run the following commands:
# modelRQ1_table <- updateColumnsOfModel1(modelRQ1_table)
# 
# model1_latex <- xtable(modelRQ1_table)
# model1_latex <- print.xtable(model1_latex, include.rownames=FALSE)
# 
# model1_latex <- gsub("duration\\\\_CR", "DurationCR", model1_latex)
# 
# model1_latex <- gsub("Variable", "", model1_latex)
# model1_latex <- gsub("\\{llll\\}\n  \\\\hline", "\\{lrrr\\}", model1_latex)
# model1_latex <- gsub("Estimate", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Estimate}}", model1_latex)
# model1_latex <- gsub("S.E.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{S.E.}}", model1_latex)
# model1_latex <- gsub("Sig.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Sig.}}", model1_latex)
# model1_latex <- gsub("\\\\centering", "\\\\centering \n \\\\caption{Logistic regression model for \\\\SDEshort.} \\\\label{tab:regression-sde}"
#                      , model1_latex)
# model1_latex <- gsub("\\\\end\\{tabular\\}", "\\\\multicolumn{4}{r}{Sig. codes:  \\‘***\\’ \\$p <\\$ 0.001, \\‘**\\’ \\$p <\\$ 0.01, \\‘*\\’ \\$p <\\$ 0.05} \\\\\\\\ \n \\\\end\\{tabular\\}"
#                      , model1_latex)
# 
# 
# model1_latex <- gsub("checklistTypeLC", "\\\\lcShortNotBold", model1_latex)
# model1_latex <- gsub("checklistTypeSC", "\\\\scShortNotBold", model1_latex)
# model1_latex <- gsub("checklistTypeNC", "\\\\ncShortNotBold", model1_latex)
# 
# model1_latex
# 
# fileConn<-file("../../../paper/tabs/regression-sde.tex", "w")
# 
# write(model1_latex, file=fileConn, append=TRUE,sep = "\n")
# 
# close(fileConn)

################LogReg Model RQ1 CKV#####################

formulaRQ1CKV = ckv ~
   checklistType +
   sde +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   checkexp +
   checkpref +
   checkrely +
   checkeff +
   checkhelps +
   professional +
   java +
   `year-cr` +
   `year-db` +
   `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` +
   itemsSkipped

print_varclus(logregrq1, formulaRQ1CKV)

# this is the new formula after we remove vars that are too correlated
formulaRQ1CKV = ckv ~
   checklistType +
   # sde +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   #designing +
   coding +
   reviewing +
   checkexp +
   # checkpref +
   # checkrely +
   # checkeff +
   # checkhelps +
   professional +
   java +
   #`year-cr` +
   #`year-db` +
   #`year-sql` +
   #`often-design` +
   `often-programming` +
   `often-cr` #+
#itemsSkipped

print_varclus(logregrq1, formulaRQ1CKV)

# RQ1: Regression model for the first code review.
modelRQ1<- print_fit(logregrq1, formulaRQ1CKV)

modelRQ1_output <- capture.output(summary(modelRQ1))

modelRQ1_output

# To automatically save the model as a latex table, run the following commands:
# modelRQ1_output <- capture.output(summary(modelRQ1))
# 
# interceptRQ1 <- strsplit(grep("Intercept", modelRQ1_output, value = TRUE), "\\s+")
# 
# modelRQ1_table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ1[[1]][2], "S.E." = interceptRQ1[[1]][3],
#                              "Sig." =interceptRQ1[[1]][6])
# 
# variables <- strsplit(modelRQ1_output, "\n")
# 
# important_variables = FALSE
# 
# modelRQ1_table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ1[[1]][2], "S.E." = interceptRQ1[[1]][3],
#                              "Sig." =interceptRQ1[[1]][6])
# 
# for (vari in variables){
#    if (!is.na(vari[1])){
#       aux <- vari[1]
#       if(grepl("Intercept", aux, fixed=TRUE)){
#          important_variables = TRUE
#       }
#       else if(grepl("---", aux, fixed=TRUE)){
#          important_variables = FALSE
#       }
#       else if(important_variables){
#          aux <- strsplit(aux, "\\s+")
#          if (startsWith(aux[[1]][1], "setexperimentCRtypefiles")){
#             modelRQ1_table <- modelRQ1_table %>% add_row("Variable" = "VulnType", "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3], 
#                                                          "Sig." =aux[[1]][6])
#          }else{
#             modelRQ1_table <- modelRQ1_table %>% add_row("Variable" = aux[[1]][1], "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3], 
#                                                          "Sig." =aux[[1]][6])
#          }
#       }
#    }
# }
# 
# modelRQ1_table <- updateColumnsOfModel1(modelRQ1_table)
# 
# model1_latex <- xtable(modelRQ1_table)
# model1_latex <- print.xtable(model1_latex, include.rownames=FALSE)
# 
# model1_latex <- gsub("duration\\\\_CR", "DurationCR", model1_latex)
# 
# model1_latex <- gsub("Variable", "", model1_latex)
# model1_latex <- gsub("\\{llll\\}\n  \\\\hline", "\\{lrrr\\}", model1_latex)
# model1_latex <- gsub("Estimate", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Estimate}}", model1_latex)
# model1_latex <- gsub("S.E.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{S.E.}}", model1_latex)
# model1_latex <- gsub("Sig.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Sig.}}", model1_latex)
# model1_latex <- gsub("\\\\centering", "\\\\centering \n \\\\caption{Logistic regression model for \\\\CKVshort.} \\\\label{tab:regression-ckv}"
#                      , model1_latex)
# model1_latex <- gsub("\\\\end\\{tabular\\}", "\\\\multicolumn{4}{r}{Sig. codes:  \\‘***\\’ \\$p <\\$ 0.001, \\‘**\\’ \\$p <\\$ 0.01, \\‘*\\’ \\$p <\\$ 0.05} \\\\\\\\ \n \\\\end\\{tabular\\}"
#                      , model1_latex)
# 
# model1_latex <- gsub("checklistTypeLC", "\\\\lcShortNotBold", model1_latex)
# model1_latex <- gsub("checklistTypeSC", "\\\\scShortNotBold", model1_latex)
# model1_latex <- gsub("checklistTypeNC", "\\\\ncShortNotBold", model1_latex)
# 
# model1_latex
# 
# fileConn<-file("../../../paper/tabs/regression-ckv.tex", "w")
# 
# write(model1_latex, file=fileConn, append=TRUE,sep = "\n")
# 
# close(fileConn)

################################################################################
######################### Robustness Test ######################################

simulated.data <- results
simulated.data$checklistType <- relevel(as.factor(simulated.data$checklistType), ref = "NF")
simulated.data$sde <- ifelse(simulated.data$VALIDATION_sde == 0, TRUE, FALSE)
simulated.data$ckv <- ifelse(simulated.data$VALIDATION_ckv == 0, TRUE, FALSE)
simulated.data$checklist <- ifelse(simulated.data$checklistType == "SC" | simulated.data$checklistType == "LC", TRUE, FALSE)

simulated.data$VALIDATION_ckv[simulated.data$checklistType == "NF"]
simulated.data$VALIDATION_sde[simulated.data$checklistType == "NF" & simulated.data$VALIDATION_ckv == 0] <- 0
simulated.data$VALIDATION_ckv[simulated.data$checklistType == "NF" & simulated.data$VALIDATION_sde == 0] <- 0

simulated.data$VALIDATION_ckv[simulated.data$checklistType == "NF"]

count(simulated.data %>% filter(simulated.data$checklistType == "NF" & simulated.data$VALIDATION_ckv == 0))
count(simulated.data %>% filter(simulated.data$checklistType == "NF" & simulated.data$VALIDATION_sde == 0))


formulaRQ1SDE = sde ~
   checklistType +
   #ckv +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   professional +
   java +
   # `year-cr` +
   # `year-db` +
   # `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
# itemsSkipped

print_varclus(simulated.data, formulaRQ1SDE)

# RQ1: Regression model for the first code review.
modelRQ1<- print_fit(logregrq1, formulaRQ1SDE)

modelRQ1_output <- capture.output(summary(modelRQ1))

formulaRQ1CKV = ckv ~
   checklistType +
   # sde +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   #designing +
   coding +
   reviewing +
   checkexp +
   # checkpref +
   # checkrely +
   # checkeff +
   # checkhelps +
   professional +
   java +
   #`year-cr` +
   #`year-db` +
   #`year-sql` +
   #`often-design` +
   `often-programming` +
   `often-cr` #+
#itemsSkipped

print_varclus(simulated.data, formulaRQ1CKV)

# RQ1: Regression model for the first code review.
modelRQ1<- print_fit(simulated.data, formulaRQ1CKV)


####### RQ2 ########

# Create Subset only containing SC and LC
resultsRQ2 <- results[results$checklistType != "NF",]
resultsRQ2$sde <- ifelse(resultsRQ2$VALIDATION_sde == 0, TRUE, FALSE)
resultsRQ2$ckv <- ifelse(resultsRQ2$VALIDATION_ckv == 0, TRUE, FALSE)
# 
formulaRQ2SDE = sde ~
   checklistType +
   ckv +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   professional +
   java +
   `year-cr` +
   `year-db` +
   `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
#itemsSkipped
# 
print_varclus(resultsRQ2, formulaRQ2SDE)

# this is the new formula after we remove vars that are too correlated
formulaRQ2SDE = sde ~
   checklistType +
   #ckv +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   professional +
   java +
   # `year-cr` +
   # `year-db` +
   # `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
# itemsSkipped

print_varclus(resultsRQ2, formulaRQ2SDE)

# To automatically save the model as a latex table, run the following commands:
# modelRQ2<- print_fit(resultsRQ2, formulaRQ2SDE)
# 
# modelRQ2_output <- capture.output(summary(modelRQ2))
# 
# interceptRQ2 <- strsplit(grep("Intercept", modelRQ2_output, value = TRUE), "\\s+")
# 
# modelRQ2table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ2[[1]][2], "S.E." = interceptRQ2[[1]][3],
#                             "Sig." =interceptRQ2[[1]][6])
# 
# variables <- strsplit(modelRQ2_output, "\n")
# 
# important_variables = FALSE
# 
# modelRQ2table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ2[[1]][2], "S.E." = interceptRQ2[[1]][3],
#                             "Sig." =interceptRQ2[[1]][6])
# 
# for (vari in variables){
#    if (!is.na(vari[1])){
#       aux <- vari[1]
#       if(grepl("Intercept", aux, fixed=TRUE)){
#          important_variables = TRUE
#       }
#       else if(grepl("---", aux, fixed=TRUE)){
#          important_variables = FALSE
#       }
#       else if(important_variables){
#          aux <- strsplit(aux, "\\s+")
#          if (startsWith(aux[[1]][1], "setexperimentCRtypefiles")){
#             modelRQ2table <- modelRQ2table %>% add_row("Variable" = "VulnType", "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3],
#                                                        "Sig." =aux[[1]][6])
#          }else{
#             modelRQ2table <- modelRQ2table %>% add_row("Variable" = aux[[1]][1], "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3],
#                                                        "Sig." =aux[[1]][6])
#          }
#       }
#    }
# }
# 
# modelRQ2table <- updateColumnsOfModel1(modelRQ2table)
# model2_latex <- xtable(modelRQ2table)
# model2_latex <- print.xtable(model2_latex, include.rownames=FALSE)
# 
# model2_latex <- gsub("duration\\\\_CR", "DurationCR", model2_latex)
# model2_latex <- gsub("question\\\\_interruption\\\\_time", "Interruptions", model2_latex)
# 
# model2_latex <- gsub("Variable", "", model2_latex)
# model2_latex <- gsub("\\{llll\\}\n  \\\\hline", "\\{lrrr\\}", model2_latex)
# model2_latex <- gsub("Estimate", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Estimate}}", model2_latex)
# model2_latex <- gsub("S.E.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{S.E.}}", model2_latex)
# model2_latex <- gsub("Sig.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Sig.}}", model2_latex)
# model2_latex <- gsub("\\\\centering", "\\\\centering \n \\\\caption{Second logistic regression model for \\\\SDEshort.} \\\\label{tab:regression-sde-rq2}"
#                      , model2_latex)
# model2_latex <- gsub("\\\\end\\{tabular\\}", "\\\\multicolumn{4}{r}{Sig. codes:  \\‘***\\’ \\$p <\\$ 0.001, \\‘**\\’ \\$p <\\$ 0.01, \\‘*\\’ \\$p <\\$ 0.05} \\\\\\\\ \n \\\\end\\{tabular\\}"
#                      , model2_latex)
# 
# model2_latex <- gsub("checklistTypeLC", "\\\\lcShortNotBold", model2_latex)
# model2_latex <- gsub("checklistTypeSC", "\\\\scShortNotBold", model2_latex)
# model2_latex <- gsub("checklistTypeNC", "\\\\ncShortNotBold", model2_latex)
# 
# model2_latex
# 
# fileConn<-file("../../../paper/tabs/regression-rq2-sde.tex", "w")
# 
# write(model2_latex, file=fileConn, append=TRUE,sep = "\n")
# 
# close(fileConn)

modelRQ2_output

formulaRQ2CKV = ckv ~
   checklistType +
   sde +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   checkexp +
   checkpref +
   checkrely +
   checkeff +
   checkhelps +
   professional +
   java +
   `year-cr` +
   `year-db` +
   `year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` +
   itemsSkipped

print_varclus(resultsRQ2, formulaRQ2CKV)

# this is the new formula after we remove vars that are too correlated
formulaRQ2CKV = ckv ~
   checklistType +
   # sde +
   duration_CR +
   question_interruption_time +
   familiar +
   incidents +
   # courses +
   practice +
   updated +
   responsibility +
   designing +
   coding +
   reviewing +
   checkexp +
   # checkpref +
   # checkrely +
   # checkeff +
   # checkhelps +
   professional +
   java +
   #`year-cr` +
   #`year-db` +
   #`year-sql` +
   `often-design` +
   `often-programming` +
   `often-cr` #+
#itemsSkipped

print_varclus(resultsRQ2, formulaRQ2CKV)

# To automatically save the model as a latex table, run the following commands:
# modelRQ2<- print_fit(resultsRQ2, formulaRQ2CKV)
# 
# modelRQ2_output <- capture.output(summary(modelRQ2))
# 
# interceptRQ2 <- strsplit(grep("Intercept", modelRQ2_output, value = TRUE), "\\s+")
# 
# modelRQ2table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ2[[1]][2], "S.E." = interceptRQ2[[1]][3],
#                             "Sig." =interceptRQ2[[1]][6])
# 
# variables <- strsplit(modelRQ2_output, "\n")
# 
# important_variables = FALSE
# 
# modelRQ2table <- data.frame("Variable" = "Intercept", "Estimate" = interceptRQ2[[1]][2], "S.E." = interceptRQ2[[1]][3],
#                             "Sig." =interceptRQ2[[1]][6])
# for (vari in variables){
#    if (!is.na(vari[1])){
#       aux <- vari[1]
#       if(grepl("Intercept", aux, fixed=TRUE)){
#          important_variables = TRUE
#       }
#       else if(grepl("---", aux, fixed=TRUE)){
#          important_variables = FALSE
#       }
#       else if(important_variables){
#          aux <- strsplit(aux, "\\s+")
#          if (startsWith(aux[[1]][1], "setexperimentCRtypefiles")){
#             modelRQ2table <- modelRQ2table %>% add_row("Variable" = "VulnType", "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3],
#                                                        "Sig." =aux[[1]][6])
#          }
#          else if(startsWith(aux[[1]][1], "(Dispersion")){
#             important_variables = FALSE
#          }else{
#             modelRQ2table <- modelRQ2table %>% add_row("Variable" = aux[[1]][1], "Estimate" = aux[[1]][2], "S.E." = aux[[1]][3],
#                                                        "Sig." =aux[[1]][6])
#          }
#       }
#    }
# }
# 
# modelRQ2table <- updateColumnsOfModel1(modelRQ2table)
# 
# model2_latex <- xtable(modelRQ2table)
# model2_latex <- print.xtable(model2_latex, include.rownames=FALSE)
# 
# model2_latex <- gsub("duration\\\\_CR", "DurationCR", model2_latex)
# model2_latex <- gsub("question\\\\_interruption\\\\_time", "Interruptions", model2_latex)
# 
# model2_latex <- gsub("Variable", "", model2_latex)
# model2_latex <- gsub("\\{llll\\}\n  \\\\hline", "\\{lrrr\\}", model2_latex)
# model2_latex <- gsub("Estimate", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Estimate}}", model2_latex)
# model2_latex <- gsub("S.E.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{S.E.}}", model2_latex)
# model2_latex <- gsub("Sig.", "\\\\multicolumn{1}{c}{\\\\cellcolor[HTML]{dadaeb}\\\\textbf{Sig.}}", model2_latex)
# model2_latex <- gsub("\\\\centering", "\\\\centering \n \\\\caption{Second logistic regression model for \\\\CKVshort.} \\\\label{tab:regression-ckv-rq2}"
#                      , model2_latex)
# model2_latex <- gsub("\\\\end\\{tabular\\}", "\\\\multicolumn{4}{r}{Sig. codes:  \\‘***\\’ \\$p <\\$ 0.001, \\‘**\\’ \\$p <\\$ 0.01, \\‘*\\’ \\$p <\\$ 0.05} \\\\\\\\ \n \\\\end\\{tabular\\}"
#                      , model2_latex)
# 
# model2_latex <- gsub("checklistTypeLC", "\\\\lcShortNotBold", model2_latex)
# model2_latex <- gsub("checklistTypeSC", "\\\\scShortNotBold", model2_latex)
# model2_latex <- gsub("checklistTypeNC", "\\\\ncShortNotBold", model2_latex)
# 
# model2_latex
# 
# fileConn<-file("../../../paper/tabs/regression-rq2-ckv.tex", "w")
# 
# write(model2_latex, file=fileConn, append=TRUE,sep = "\n")

close(fileConn)
#################################################
################ Demographics ###################

#gender
results$question_gender[results$question_gender == "m" | 
                           results$question_gender == "M"| 
                           results$question_gender == "Masculino"|
                           results$question_gender == "masculine"| 
                           results$question_gender == "male"] <- "Male"
results$question_gender[results$question_gender == "Feminine" | 
                           results$question_gender == "Feminino" |
                           results$question_gender == "female" | 
                           results$question_gender == "f"] <- "Female"

#gender
results$question_gender[results$question_gender != "Male" &
                           results$question_gender != "Female"] <- "Not Disclosed"

results$question_gender[is.na(results$question_gender)] <- "Not Disclosed"

any(is.na(results$question_gender))
any(is.na(results$checklistType))

total.men <- count(results %>% filter(results$question_gender == "Male"))
total.women <- count(results %>% filter(results$question_gender == "Female"))
total.gender_others <- count(results %>% filter(results$question_gender == 
                                                   "Not Disclosed"))

tbl = table(results$checklistType, results$question_gender) 
chisq.test(tbl) #p-value = 0.1866 - Warning: approximation might be incorrect
dim(tbl)
cramerV(tbl) ##0.171 df*=1 (medium)


NF <- results %>% filter(results$checklistType == "NF")

NF$experience_level = NF$professional

NF$experience_level[NF$professional < 4] <- "low"
NF$experience_level[NF$professional == 4] <- "medium"
NF$experience_level[NF$professional > 4] <- "high"

#NF <- mutate(NF, experience_level = ifelse(NF$professional<4, 'low', 'high'))

tbl = table(NF$experience_level, NF$vuln_found) 
chisq.test(tbl) #
dim(tbl)
cramerV(tbl) 

NC <- results %>% filter(results$checklistType == "NC")

#NC <- mutate(NC, experience_level = ifelse(NC$professional<4, 'low', 'high'))

NC$experience_level = NC$professional
NC$experience_level[NC$professional < 4] <- "low"
NC$experience_level[NC$professional == 4] <- "medium"
NC$experience_level[NC$professional > 4] <- "high"

tbl = table(NC$experience_level, NC$vuln_found) 
chisq.test(tbl) #
dim(tbl)
cramerV(tbl) 

SC <- results %>% filter(results$checklistType == "SC")

# SC <- mutate(SC, experience_level = ifelse(SC$professional<4, 'low', 'high'))

SC$experience_level = SC$professional
SC$experience_level[SC$professional < 4] <- "low"
SC$experience_level[SC$professional == 4] <- "medium"
SC$experience_level[SC$professional > 4] <- "high"

tbl = table(SC$experience_level, SC$vuln_found) 
chisq.test(tbl) #
dim(tbl)
cramerV(tbl) 

LC <- results %>% filter(results$checklistType == "LC")

# LC <- mutate(LC, experience_level = ifelse(LC$professional<4, 'low', 'high'))

LC$experience_level = LC$professional
LC$experience_level[LC$professional < 4] <- "low"
LC$experience_level[LC$professional == 4] <- "medium"
LC$experience_level[LC$professional > 4] <- "high"

tbl = table(LC$experience_level, LC$vuln_found) 
chisq.test(tbl) #
dim(tbl)
cramerV(tbl) 

#############

nf.vs.nc <- matrix(c(as.numeric(count(NC %>% filter(vuln_found != "none"))),
                     as.numeric(count(NC %>% filter(vuln_found == "none"))),
                     as.numeric(count(NF %>% filter(vuln_found != "none"))),
                     as.numeric(count(NF %>% filter(vuln_found == "none")))),
                   ncol=2)
rownames(nf.vs.nc) <- c('found', 'not found')
colnames(nf.vs.nc) <- c('nc', 'nf')

# Odds radio of finding a vulnerability in the 2 groups.
odds_nf.vs.nc <- epi.2by2(nf.vs.nc, method="cohort.count", conf.level=0.95)

odds_nf.vs.nc <- capture.output(odds_nf.vs.nc)

aux <- strsplit(grep("Odds ratio", odds_nf.vs.nc, value = TRUE), "\\s+")
odds_nf.vs.nc <- aux[[1]][3]

odds_nf.vs.nc

########

nf.vs.lc <- matrix(c(as.numeric(count(LC %>% filter(vuln_found != "none"))),
                     as.numeric(count(LC %>% filter(vuln_found == "none"))),
                     as.numeric(count(NF %>% filter(vuln_found != "none"))),
                     as.numeric(count(NF %>% filter(vuln_found == "none")))),
                   ncol=2)
rownames(nf.vs.lc) <- c('found', 'not found')
colnames(nf.vs.lc) <- c('lc', 'nf')

# Odds radio of finding the vulnerability in the 2 groups.
odds_nf.vs.lc <- epi.2by2(nf.vs.lc, method="cohort.count", conf.level=0.95)

odds_nf.vs.lc <- capture.output(odds_nf.vs.lc)

aux <- strsplit(grep("Odds ratio", odds_nf.vs.lc, value = TRUE), "\\s+")
odds_nf.vs.lc <- aux[[1]][3]

odds_nf.vs.lc

#######

nf.vs.sc <- matrix(c(as.numeric(count(SC %>% filter(vuln_found != "none"))),
                     as.numeric(count(SC %>% filter(vuln_found == "none"))),
                     as.numeric(count(NF %>% filter(vuln_found != "none"))),
                     as.numeric(count(NF %>% filter(vuln_found == "none")))),
                   ncol=2)
rownames(nf.vs.sc) <- c('found', 'not found')
colnames(nf.vs.sc) <- c('sc', 'nf')

# Odds radio of finding the vulnerability in the 2 groups.
odds_nf.vs.sc <- epi.2by2(nf.vs.sc, method="cohort.count", conf.level=0.95)

odds_nf.vs.sc <- capture.output(odds_nf.vs.sc)

aux <- strsplit(grep("Odds ratio", odds_nf.vs.sc, value = TRUE), "\\s+")
odds_nf.vs.sc <- aux[[1]][3]

odds_nf.vs.sc

##################################################
################## Latex #########################
# # 
# fileConn<-file("../../../paper/sections/commands-R.tex", "w")
# 
# write(paste0("\\newcommand{\\numParticipants}{", total.participants, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\numNC}{", total.NC, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\numNF}{", total.NF, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\numSC}{", total.SC, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\numLC}{", total.LC, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\numSecondModel}{", total.participants - total.NF, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.students = count(results %>% filter(results$question_demo4 == 0 | results$question_demo4 == "0 + 2" |
#                                              results$question_demo4 == "0 + 3" | results$question_demo4 == "0 + 4"))
# per.students <- round(total.students / total.participants * 100)
# 
# write(paste0("\\newcommand{\\totalStudents}{", total.students, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perStudents}{", per.students, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.it.operators = count(results %>% filter(results$question_demo5 == 4))
# total.prof = count(results %>% filter(results$question_demo5 == 6))
# total.other.job = count(results %>% filter(results$question_demo5 == 8))
# 
# write(paste0("\\newcommand{\\totalIToperators}{", total.it.operators, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalProf}{", total.prof, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalOtherJob}{", total.other.job, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.software.developers = count(results %>% filter(results$question_demo5 == 0))
# total.software.arch = count(results %>% filter(results$question_demo5 == 3))
# total.managers = count(results %>% filter(results$question_demo5 == 5))
# total.engineers <- total.software.developers + total.software.arch
# per.engineers <- round(total.engineers / total.participants * 100)
# 
# write(paste0("\\newcommand{\\totalManager}{", total.managers, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalEngineers}{", total.engineers, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perEngineers}{", per.engineers, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# #
# total.experience.over.three.years = count(results %>% filter(results$professional > 3))
# per.experience.over.three.years <- round(total.experience.over.three.years  / total.participants * 100)
# 
# total.experience.over.two.years = count(results %>% filter(results$professional > 2))
# per.experience.over.two.years <- round(total.experience.over.two.years  / total.participants * 100)
# 
# write(paste0("\\newcommand{\\totalExperienceOverThree}{", total.experience.over.three.years, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perExperienceOverThree}{", per.experience.over.three.years, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalExperienceOverTwo}{", total.experience.over.two.years, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perExperienceOverTwo}{", per.experience.over.two.years, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.experience.3to5 = count(results %>% filter(results$professional == 4))
# per.experience.3to5 <- round(total.experience.3to5  / total.participants * 100)
# total.experience.6to10 = count(results %>% filter(results$professional == 5))
# per.experience.6to10 <- round(total.experience.6to10  / total.participants * 100)
# total.experience.over11 = count(results %>% filter(results$professional == 6))
# per.experience.over11 <- round(total.experience.over11  / total.participants * 100)
# 
# write(paste0("\\newcommand{\\totalExperienceThreetoFive}{", total.experience.3to5, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perExperienceThreetoFive}{", per.experience.3to5, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalExperienceSixtoTen}{", total.experience.6to10, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perExperienceSixtoTen}{", per.experience.6to10, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalExperienceOverEleven}{", total.experience.over11, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perExperienceOverEleven}{", per.experience.over11, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.often.cr = count(results %>% filter(results$`often-programming` == 5))
# per.often.cr <- round(total.often.cr  / total.participants * 100)
# 
# total.often.design = count(results %>% filter(results$`often-design` == 5))
# per.often.design <- round(total.often.design  / total.participants * 100)
# 
# total.often.programming = count(results %>% filter(results$`often-programming` == 5))
# per.often.programming <- round(total.often.programming  / total.participants * 100)
# 
# write(paste0("\\newcommand{\\totalOftenCR}{", total.often.cr, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perOftenCR}{", per.often.cr, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalOftenDesign}{", total.often.design, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perOftenDesign}{", per.often.design, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalOftenProgramming}{", total.often.programming, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perOftenProgramming}{", per.often.programming, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalMale}{", total.men, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalFemale}{", total.women, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalOtherGender}{", total.gender_others, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalSDEfound}{", total.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalCKVfound}{", total.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalSDEmissed}{", total.sde.missed, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalCKVmissed}{", total.ckv.missed, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# 
# write(paste0("\\newcommand{\\perSDEfound}{", per.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perCKVfound}{", per.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perSDEmissed}{", per.sde.missed, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perCKVmissed}{", per.ckv.missed, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalFoundAtLeastOne}{", total.found.at.least.one, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.lc.sc <- total.LC + total.SC
# total.lc.sc.found.not.both <- count(results %>% filter(results$vuln_found != "both" & (results$checklistType == "LC" | results$checklistType == "SC")))
# total.lc.sc.found.none <- count(results %>% filter(results$vuln_found == "none" & (results$checklistType == "LC" | results$checklistType == "SC")))
# 
# write(paste0("\\newcommand{\\totalLCSCNone}{", total.lc.sc.found.none, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalLCSCNotBoth}{", total.lc.sc.found.not.both, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalLCSC}{", total.lc.sc, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.nf.sde.found <- count(NF %>% filter(NF$VALIDATION_sde==0))
# per.nf.sde.found <- round(total.nf.sde.found  / total.NF * 100)
# 
# total.nc.sde.found <- count(NC %>% filter(NC$VALIDATION_sde==0))
# per.nc.sde.found <- round(total.nc.sde.found  / total.NC * 100)
# 
# total.lc.sde.found <- count(LC %>% filter(LC$VALIDATION_sde==0))
# per.lc.sde.found <- round(total.lc.sde.found  / total.LC * 100)
# 
# total.sc.sde.found <- count(SC %>% filter(SC$VALIDATION_sde==0))
# per.sc.sde.found <- round(total.sc.sde.found  / total.SC * 100)
# 
# write(paste0("\\newcommand{\\totalNFsdeFound}{", total.nf.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perNFsdeFound}{", per.nf.sde.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalNCsdeFound}{", total.nc.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perNCsdeFound}{", per.nc.sde.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalLCsdeFound}{", total.lc.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perLCsdeFound}{", per.lc.sde.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalSCsdeFound}{", total.sc.sde.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perSCsdeFound}{", per.sc.sde.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# 
# total.nf.ckv.found <- count(NF %>% filter(NF$VALIDATION_ckv==0))
# per.nf.ckv.found <- round(total.nf.ckv.found  / total.NF * 100)
# 
# total.nf.ckv.missed <- count(NF %>% filter(NF$VALIDATION_ckv==1))
# per.nf.ckv.missed <- round(total.nf.ckv.missed  / total.NF * 100)
# 
# total.nc.ckv.found <- count(NC %>% filter(NC$VALIDATION_ckv==0))
# per.nc.ckv.found <- round(total.nc.ckv.found  / total.NC * 100)
# 
# total.lc.ckv.found <- count(LC %>% filter(LC$VALIDATION_ckv==0))
# per.lc.ckv.found <- round(total.lc.ckv.found  / total.LC * 100)
# 
# total.sc.ckv.found <- count(SC %>% filter(SC$VALIDATION_ckv==0))
# per.sc.ckv.found <- round(total.sc.ckv.found  / total.SC * 100)
# 
# 
# write(paste0("\\newcommand{\\totalNFckvFound}{", total.nf.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perNFckvFound}{", per.nf.ckv.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalNFckvMissed}{", total.nf.ckv.missed, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perNFckvMissed}{", per.nf.ckv.missed, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalNCckvFound}{", total.nc.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perNCckvFound}{", per.nc.ckv.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalLCckvFound}{", total.lc.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perLCckvFound}{", per.lc.ckv.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\totalSCckvFound}{", total.sc.ckv.found, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perSCckvFound}{", per.sc.ckv.found, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\oddsRatioNFvsNC}{", round(as.numeric(odds_nf.vs.nc)), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\oddsRatioNFvsNCTXT}{", as.english(round(as.numeric(odds_nf.vs.nc))), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\oddsRatioNFvsLC}{", round(as.numeric(odds_nf.vs.lc)), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\oddsRatioNFvsLCTXT}{", as.english(round(as.numeric(odds_nf.vs.lc))), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\oddsRatioNFvsSC}{", round(as.numeric(odds_nf.vs.sc)), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\oddsRatioNFvsSCTXT}{", as.english(round(as.numeric(odds_nf.vs.sc))), "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# total.ckv.found.not.nf <- count(results %>% filter(results$checklistType !="NF" & results$VALIDATION_ckv == 0))
# total.sde.found.not.nf <- count(results %>% filter(results$checklistType !="NF" & results$VALIDATION_sde == 0))
# 
# per.ckv.found.not.nf <- round(total.ckv.found.not.nf  / (total.SC + total.NC + total.LC ) * 100)
# per.sde.found.not.nf <- round(total.sde.found.not.nf  / (total.SC + total.NC + total.LC ) *100)
# 
# write(paste0("\\newcommand{\\totalCKVnotNF}{", total.ckv.found.not.nf, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\totalSDEnotNF}{", total.sde.found.not.nf, "\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# write(paste0("\\newcommand{\\perCKVnotNF}{", per.ckv.found.not.nf, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# write(paste0("\\newcommand{\\perSDEnotNF}{", per.sde.found.not.nf, "\\%\\xspace}"), file=fileConn, append=TRUE,sep = "\n")
# 
# close(fileConn)


########## Plots #############

#question_dem_5 - current position
results$question_demo5 <- as.character(results$question_demo5)
results$question_demo5[results$question_demo5 == "0"] <- "Software Engineer"
results$question_demo5[results$question_demo5 == "1"] <- "Penetration Tester"
results$question_demo5[results$question_demo5 == "2"] <- "Bug bounty Hunter"
results$question_demo5[results$question_demo5 == "3"] <- "Software Engineer"
results$question_demo5[results$question_demo5 == "4"] <- "IT Operations"
results$question_demo5[results$question_demo5 == "5"] <- "Project Manager"
results$question_demo5[results$question_demo5 == "6"] <- "Researcher/Professor"
results$question_demo5[results$question_demo5 == "7"] <- "PhD Student"
results$question_demo5[results$question_demo5 == "8"] <- "Other"

empl_position <- table(results$question_demo5)

empl_position <- as.data.frame(empl_position)

colnames(empl_position) <- c("Position", "Freq")

empl_position

category_order <- rev(c("IT Operations",
                        "Other",
                        "PhD Student",
                        "Project Manager",
                        "Researcher/Professor",
                        "Software Engineer"))

empl_position$Position<- factor(empl_position$Position, levels = category_order)


plot.position <- ggplot(empl_position, aes(x = Position, y = Freq, label = Freq)) +
   geom_bar(stat = "identity", position = "dodge", fill = "#6a51a3") +
   geom_text(position = position_dodge(width= 1), vjust= 0.6, hjust = -0.3, size = 4) + 
   theme_minimal() + 
   theme(axis.title.x=element_blank(), axis.title.y=element_blank(),
         axis.text.x = element_blank(),
         axis.text.y =  element_text(color="black", size=12, angle=0),
         panel.grid.major.y = element_blank(),
         aspect.ratio = .5,
         legend.text=element_text(size=10)) +
   coord_flip()

plot.position

# ggsave("../../../paper/figs/position_crop.pdf", plot = plot.position, width = 500/72, height = 200/72, dpi = 72)


#Experience
results$professional <- as.character(results$professional)
results$professional[results$professional == "1"] <- "None"
results$professional[results$professional == "2"] <- "1 year or less"
results$professional[results$professional == "3"] <- "2 years"
results$professional[results$professional == "4"] <- "3-5 years"
results$professional[results$professional == "5"] <- "6-10 years"
results$professional[results$professional == "6"] <- "11 years or more"

results$java <- as.character(results$java)
results$java[results$java == "1"] <- "None"
results$java[results$java == "2"] <- "1 year or less"
results$java[results$java == "3"] <- "2 years"
results$java[results$java == "4"] <- "3-5 years"
results$java[results$java == "5"] <- "6-10 years"
results$java[results$java == "6"] <- "11 years or more"

results$`year-cr` <- as.character(results$`year-cr`)
results$`year-cr`[results$`year-cr` == "1"] <- "None"
results$`year-cr`[results$`year-cr` == "2"] <- "1 year or less"
results$`year-cr`[results$`year-cr` == "3"] <- "2 years"
results$`year-cr`[results$`year-cr` == "4"] <- "3-5 years"
results$`year-cr`[results$`year-cr` == "5"] <- "6-10 years"
results$`year-cr`[results$`year-cr` == "6"] <- "11 years or more"

results$`year-db` <- as.character(results$`year-db`)
results$`year-db`[results$`year-db` == "1"] <- "None"
results$`year-db`[results$`year-db` == "2"] <- "1 year or less"
results$`year-db`[results$`year-db` == "3"] <- "2 years"
results$`year-db`[results$`year-db` == "4"] <- "3-5 years"
results$`year-db`[results$`year-db` == "5"] <- "6-10 years"
results$`year-db`[results$`year-db` == "6"] <- "11 years or more"

results$`year-sql` <- as.character(results$`year-sql`)
results$`year-sql`[results$`year-sql` == "1"] <- "None"
results$`year-sql`[results$`year-sql` == "2"] <- "1 year or less"
results$`year-sql`[results$`year-sql` == "3"] <- "2 years"
results$`year-sql`[results$`year-sql` == "4"] <- "3-5 years"
results$`year-sql`[results$`year-sql` == "5"] <- "6-10 years"
results$`year-sql`[results$`year-sql` == "6"] <- "11 years or more"

java <- results %>%
   group_by(java) %>%
   summarise(count = n())
colnames(java) <- c("Years", "Java")

professional <- results %>%
   group_by(professional) %>%
   summarise(count = n())
colnames(professional) <- c("Years", "Professional\nDevelopment")

cr <- results %>%
   group_by(`year-cr`) %>%
   summarise(count = n())
colnames(cr) <- c("Years", "Code Review")

db <- results %>%
   group_by(`year-db`) %>%
   summarise(count = n())
colnames(db) <- c("Years", "Web Applications")

sql_ <- results %>%
   group_by(`year-sql`) %>%
   summarise(count = n())
colnames(sql_) <- c("Years", "Databases")

experience <- merge(java,professional)
experience <- merge(experience,cr)
# experience <- merge(experience,db)
experience <- merge(experience,sql_)

experience.m <- melt(experience, id.vars="Years")

experience.m$Years <- factor(experience.m$Years,levels = c("None", "1 year or less", "2 years", "3-5 years", "6-10 years", "11 years or more"))

java

#Practice
results$`often-design` <- as.character(results$`often-design`)
results$`often-design`[results$`often-design` == "1"] <- "Not at all"
results$`often-design`[results$`often-design` == "2"] <- "About once a year"
results$`often-design`[results$`often-design` == "3"] <- "About once a month"
results$`often-design`[results$`often-design` == "4"] <- "About once a week"
results$`often-design`[results$`often-design` == "5"] <- "Daily or more often"

`often-design` <- results %>%
   group_by(`often-design`) %>%
   summarise(count = n())
colnames(`often-design`) <- c("Years", "Designing")

results$`often-programming` <- as.character(results$`often-programming`)
results$`often-programming`[results$`often-programming` == "1"] <- "Not at all"
results$`often-programming`[results$`often-programming` == "2"] <- "About once a year"
results$`often-programming`[results$`often-programming` == "3"] <- "About once a month"
results$`often-programming`[results$`often-programming` == "4"] <- "About once a week"
results$`often-programming`[results$`often-programming` == "5"] <- "Daily or more often"

`often-programming` <- results %>%
   group_by(`often-programming`) %>%
   summarise(count = n())
colnames(`often-programming`) <- c("Years", "Developing")

results$`often-cr` <- as.character(results$`often-cr`)
results$`often-cr`[results$`often-cr` == "1"] <- "Not at all"
results$`often-cr`[results$`often-cr` == "2"] <- "About once a year"
results$`often-cr`[results$`often-cr` == "3"] <- "About once a month"
results$`often-cr`[results$`often-cr` == "4"] <- "About once a week"
results$`often-cr`[results$`often-cr` == "5"] <- "Daily or more often"

`often-cr` <- results %>%
   group_by(`often-cr`) %>%
   summarise(count = n())
colnames(`often-cr`) <- c("Years", "Reviewing")

practice <- merge(`often-design`,`often-programming`)
practice <- merge(practice,`often-cr`)

practice.m <- melt(practice, id.vars="Years")

`often-design`

practice

category_order <- rev(c("Not at all", 
                        "About once a year", 
                        "About once a month",
                        "About once a week",
                        "Daily or more often"))

practice.m$Years<- factor(practice.m$Years, levels = category_order)



practice.m$variable<- factor(practice.m$variable,levels = c("Reviewing",
                                                            "Developing",
                                                            "Designing"))

practice.m <- practice.m %>% arrange(factor(Years, levels = category_order), 
                                     factor(variable, c("Reviewing",
                                                        "Developing",
                                                        "Designing")))

practice.m

df <- data.frame(x=1:8, y=1, col=letters[1:8])

g <- ggplot(df, aes(x=x, y=y, color=col)) + geom_point(size=5) +
   scale_color_brewer(palette="Purples")

colors <- ggplot_build(g)$data[[1]]$colour

colorsP<-rev(c(colors[2],colors[3],colors[4],colors[6],colors[7]))

label.color <- c("white","white","white","black","black",
                 "black","black","black","black","black",
                 "black","black","black","black","black")

likert.practice <- ggplot(practice.m, aes(x = variable, y = value))+
   geom_bar(data = practice.m, aes(fill=Years), 
            position = position_fill(reverse = TRUE), stat="identity",
            width = 0.7) +
   geom_text(label = practice.m$value, size = 5, 
             position = position_fill(vjust = 0.5), color = label.color) +
   coord_flip() + 
   ggtitle("Coding Practice")+
   ylab("")+
   xlab("")+
   scale_fill_manual(values=colorsP)+
   theme_minimal() + 
   theme(legend.position="bottom",
         legend.text=element_text(size=10),
         panel.grid.major.y = element_blank(), 
         panel.grid.minor.x = element_blank(),
         plot.title = element_text(size=20), 
         axis.text.x = element_text(color="black", size=13, angle=0),
         axis.text.y =  element_text(color="black", size=13, angle=0),
         panel.grid.major = element_line(colour = "grey70")) + 
   scale_y_continuous(labels = scales::percent_format(accuracy = 1)) + 
   guides(fill = guide_legend(title="")) +
   theme(plot.title = element_text(hjust = -0.22, vjust=2.12))

likert.practice

#ggsave("../../../paper/figs/likert-practice.pdf", plot = likert.practice, width = 600/72, height = 200/72, dpi = 72)

#system2(command = "pdfcrop",
#        args    = c("../../../paper/figs/likert-practice.pdf",
#                    "../../../paper/figs/likert-practice.pdf")
#)
# 
# experience.m

colorsP<-rev(c(colors[2],colors[3],colors[4],colors[5],colors[6],colors[7]))

category_order <- rev(c("None",
                        "1 year or less", 
                        "2 years", "3-5 years",
                        "6-10 years",
                        "11 years or more"))

experience.m$Years<- factor(experience.m$Years, levels = category_order)

experience.m


experience.m <- experience.m %>% arrange(factor(Years, levels = category_order), 
                                         factor(variable, 
                                                c("Professional\nDevelopment",
                                                  "Java",
                                                  "Databases", 
                                                  "Code Review")))

experience.m$variable<- factor(experience.m$variable,
                               levels = c("Professional\nDevelopment",
                                          "Java",
                                          "Databases", 
                                          "Code Review"))

experience.m

label.color <- c("white","white","white","white","black","black",
                 "black","black","black","black","black","black",
                 "black","black","black","black","black","black",
                 "black","black","black","black","black","black")

experience.m

colorsP<-rev(c(colors[2],colors[3],colors[4],colors[5],colors[6],colors[7]))


likert.experience <- ggplot(experience.m, aes(x = variable, y = value))+
   geom_bar(data = experience.m, aes(fill=Years), 
            position = position_fill(reverse = TRUE), stat="identity",
            width = 0.7) +
   geom_text(label = experience.m$value, size = 5, 
             position = position_fill(vjust = 0.5), color = label.color) +
   coord_flip() + 
   ggtitle("Experience")+
   ylab("")+
   xlab("")+
   scale_fill_manual(values=colorsP)+
   theme_minimal() + 
   theme(legend.position="bottom",
         legend.text=element_text(size=12),
         panel.grid.major.y = element_blank(), 
         panel.grid.minor.x = element_blank(),
         plot.title = element_text(size=20), 
         axis.text.x = element_text(color="black", size=13, angle=0),
         axis.text.y =  element_text(color="black", size=13, angle=0),
         panel.grid.major = element_line(colour = "grey70")) + 
   scale_y_continuous(labels = scales::percent_format(accuracy = 1)) + 
   guides(fill = guide_legend(nrow=1, title="")) +
   theme(plot.title = element_text(hjust = -0.26, vjust=2.12))


likert.experience

# ggsave("../../../paper/figs/likert-experience.pdf", plot = likert.experience, width = 600/72, height = 225/72, dpi = 72)

