# Question Overview

## No Checklist

#### Index
- Donation on your behalf. As mentioned above, to thank you for your participation in the experiment, we are going to donate 5 USD (or its equivalent) to a non-profit organization on your behalf. The donation is made only on behalf of participants whose experiment is valid and complete. The donation will be done at the end of the entire study and will be announced from this Twitter Account. Please select the organization you prefer:
     - Wikimedia Foundation
     - Mozilla Foundation
     - Free Software Foundation
     - University Hospital Zurich Foundation
     - Other(*)
- Data handling policy
     - I agree with the data handling policy

---
#### Experiment
- You have not added any review comment yet. Do you want to complete the review anyway?
     - No
     - Yes
- How long have you been interrupted during the execution of the review?
     - No interruption time
     - 1-2 minutes
     - up to 5 minutes
     - up to 10 minutes
     - more than 10 minutes
---
#### Experiment Conclusion
- (**1**) Did you find the Sensitive Information Leakage vulnerability?
     - Yes (**1.1**)
     - No (**1.2**)

- (**1.1**) Can you explain why you think you found the Sensitive Information Leakage vulnerability?

- (**1.2**) Why do you think you did you miss the Sensitive Information Leakage vulnerability, and why did the checklist not help in finding it?

- (**2**) Did you find the MD5 cryptographic hash algorithm vulnerability?
     - Yes (**2.1**)
     - No (**2.2**)

- (**2.1**) Can you explain why you think you found the MD5 cryptographic hash algorithm vulnerability?

- (**2.2**) Why do you think you did miss the MD5 cryptographic hash algorithm vulnerability, and why did the checklist not help in finding it?

---
#### Survey
Please choose an option for the following statements: [*No/Yes*]:
- I am familiar with the concept of software vulnerabilities
- I have experience with security incidents
- I have participated in security courses and/or training
- I use what I have learned in practice

##

- What kind of security courses and/or training have you participated in? Please check all that apply.
     - Lectures
     - Conference
     - Seminar
     - Hands-on course
     - Professional training

##

- What was your role in the security incidents you have experienced? Please check all that apply.
     - I introduced the vulnerability
     - I found the vulnerability
     - I fixed the vulnerability
     - I exploited the vulnerability

##

Specify your agreement with the following statements: [*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I keep myself up to date with security information
- It is part of my job responsibility to look for vulnerabilities
- I actively consider vulnerabilities when designing software
- I actively consider vulnerabilities when coding
- I actively look for vulnerabilities when reviewing

##

- How often have you reported a vulnerability while code reviewing in the last year?
     - Never
     - About once
     - About once a month
     - About once a week
     - Daily or more often

##

- How much time per code review do you spend on average looking for vulnerabilities? (in percentage)

##

Please answer the following questions regarding checklists: [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- I prefer using checklists for code reviewing
- Checklists are mainly for inexperienced code reviewers
- Checklists improve my code review efficiency
- Checklists help in finding security issues

##

[*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I have used checklists for code review before

##

- In what context have you already used Checklists?

##

Considering the project you work on the most, please rate your agreement with the following statements. [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- Software developers are aware of potential security issues
- Software developers have expertise in software security
- Detection tools are used to find software vulnerabilities
- Checklists are used to find software vulnerabilites
- Code review is used to find software vulnerabilities
- Third-party libraries are checked for security issues
- Security documentation and training are available
- Enough time is available to consider security aspects

##

Considering the project you work on the most, rate how effective, in your opinion, the following measures would be in reducing the number of vulnerabilities. [*Not at all effective/Slightly effective/Somewhat effective/Very effective/Extremely effective/I don't know/Not Applicable*]:
- Increasing awareness of potential security issues
- Increasing the use of code review to find software vulnerabilities
- Writing more and better tests
- Having access to security vulnerability checklists
- Having more and better security documentation and training
- Reinforcing the security check of third-party libraries
- Having people responsible for security in the project/company
- Increasing the use of tools to identify security bugs
- Learning from past vulnerabilities that affected the project
- Having more time to consider security aspects

##

- Would there be any other useful solutions to reduce the number of vulnerabilities in the project you work on the most?
---
#### Demographic Questions
- (**1**) What is your gender?

- (**2**) What is your highest achieved level of education?
     - High School but did not graduate
     - High School graduate or GED
     - Some college or 2-year degree
     - Bachelor in CS (Computer Science)
     - Bachelor in STEM (Science, Technology, Engineering, and Mathematics)
     - Bachelor in a different area than CS or STEM
     - Master in CS
     - Master in STEM
     - Master in a different area than CS or STEM
     - Ph.D. or higher academic title in CS
     - Ph.D. or higher academic title in STEM
     - Ph.D. or higher academic title in a different area than CS or STEM

- (**3**) What's your current employment status?
     - Student (**4.1**)
     - Intern (**4.1**)
     - Part-time position (**4.2**)
     - Full-time position (**4.2**)
     - Unemployed

- (**4.1**) Are you currently enrolled in a degree-granting program?
     - Yes
     - No

- (**4.2**) What is your current position related to?
     - Software developer
     - Penetration tester
     - Bug bounty hunter
     - Software architect
     - IT operations
     - Project manager
     - Researcher / Professor
     - PhD student
     - Other

- (**4.2**) How many employees does your company have?
     - 1 employee
     - 2-10 employees
     - 11-19 employees
     - 20-50 employees
     - 51-100 employees
     - 100-200 employees
     - Over 200 employees

- (**4.2**) How big is your immediate team?
     - 1 person
     - 2-5 people
     - 6-10 people
     - 11-20 people
     - 21-50 people
     - Over 50 people

- Do you contribute to open-source software systems as one of your main programming activities?
     - Yes
     - No

- Please specify for how many years you have performed the following activities [*None/1 year or less/2 years/3-5 years/6-10 years/11 years or more*]:
     - Developed software in a professional setting (e.g., as employee of an IT-company or Open-Source contributor)
     - Programmed in Java (also not professionally)
     - Reviewed code
     - Worked with web applications
     - Worked with applications using databases

- Please specify how often you have performed the following activities in the last year:  [*Not at all/About once/About once a month/About once a week/Daily or more often*]:
     - Designed code
     - Developed code
     - Reviewed code
---
#### Final Feedback

- If you have any comments on the experiment, please add them here:

- All your data is anonymous! We will analyze it. May we also share it in a public research dataset?
     - Yes
     - No

- If you would like to receive the results of this study, please leave your email here. Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.

- If you would like to be interviewed in the context of this study, please leave your email here.
Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.
----
## Short Checklist

#### Index
- Donation on your behalf. As mentioned above, to thank you for your participation in the experiment, we are going to donate 5 USD (or its equivalent) to a non-profit organization on your behalf. The donation is made only on behalf of participants whose experiment is valid and complete. The donation will be done at the end of the entire study and will be announced from this Twitter Account. Please select the organization you prefer:
     - Wikimedia Foundation
     - Mozilla Foundation
     - Free Software Foundation
     - University Hospital Zurich Foundation
     - Other(*)
- Data handling policy
     - I agree with the data handling policy
---
#### Experiment
- You have X unfilled checklist items. You have not added any review comment yet. Do you want to complete the review anyway?
     - No
     - Yes
- How long have you been interrupted during the execution of the review?
     - No interruption time
     - 1-2 minutes
     - up to 5 minutes
     - up to 10 minutes
     - more than 10 minutes
---
#### Checklist Items
[*Yes/No/Irrelevant*]
- Input Handling
     - Is user-supplied input properly validated, sanitized, and filtered?
     - Is untrusted input data constrained for type, length, format, and range?

- Authentication
     - Are minimum and maximum password lengths enforced?
     - Is the set of allowed characters for passwords limited?

- Data Protection
     - Is sensitive data logged in a masked, sanitized, hashed, or encrypted state?
     - Are up-to-date and appropriately strong standard encryption algorithms, protocols and keys used?
     - Are passwords stored in an encrypted format?
---
#### Experiment Conclusion
- (**1**) Did you find the Sensitive Information Leakage vulnerability?
     - Yes (**1.1**)
     - No (**1.2**)

- (**1.1**) Did the checklist help you in identifying the Sensitive Information Leakage vulnerability?
     - Yes (**1.1.1**)
     - No (**1.1.2**)

- (**1.2**) Why do you think you did you miss the Sensitive Information Leakage vulnerability, and why did the checklist not help in finding it?

- (**1.1.1**) Can you explain how the checklist helped you in identifying the Sensitive Information Leakage vulnerability?

- (**1.1.2**) Can you explain why the checklist did not help you identifying the Sensitive Information Leakage vulnerability?

- (**2**) Did you find the MD5 cryptographic hash algorithm vulnerability?
     - Yes (**2.1**)
     - No (**2.2**)

- (**2.1**) Did the checklist help you in identifying the MD5 cryptographic hash algorithm vulnerability?
     - Yes (**2.1.1**)
     - No (**2.1.2**)

- (**2.2**) Why do you think you did miss the MD5 cryptographic hash algorithm vulnerability, and why did the checklist not help in finding it?

- (**2.1.1**) Can you explain how the checklist helped you in identifying the MD5 cryptographic hash algorithm vulnerability?

- (**2.1.2**) Can you explain why the checklist did not help you identifying the MD5 cryptographic hash algorithm vulnerability?

- The checklist was...
     - ...too short.
     - ...just right in length.
     - ...too long.

- The checklist was...
     - ...too specific.
     - ...just the right amount of detail.
     - ...too general.

- The checklist was...
     - ...easy to use.
     - ...neither easy nor complicated to use.
     - ...complicated to use.

- Can you explain why you did not fill in all checklist items?
---
#### Survey
Please choose an option for the following statements: [*No/Yes*]:
- I am familiar with the concept of software vulnerabilities
- I have experience with security incidents
- I have participated in security courses and/or training
- I use what I have learned in practice

##

- What kind of security courses and/or training have you participated in? Please check all that apply.
     - Lectures
     - Conference
     - Seminar
     - Hands-on course
     - Professional training

##

- What was your role in the security incidents you have experienced? Please check all that apply.
     - I introduced the vulnerability
     - I found the vulnerability
     - I fixed the vulnerability
     - I exploited the vulnerability

##

Specify your agreement with the following statements: [*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I keep myself up to date with security information
- It is part of my job responsibility to look for vulnerabilities
- I actively consider vulnerabilities when designing software
- I actively consider vulnerabilities when coding
- I actively look for vulnerabilities when reviewing

##

- How often have you reported a vulnerability while code reviewing in the last year?
     - Never
     - About once
     - About once a month
     - About once a week
     - Daily or more often

##

- How much time per code review do you spend on average looking for vulnerabilities? (in percentage)

##

Please answer the following questions regarding checklists: [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- I prefer using checklists for code reviewing
- Checklists are mainly for inexperienced code reviewers
- Checklists improve my code review efficiency
- Checklists help in finding security issues

##

[*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I have used checklists for code review before

##

- In what context have you already used Checklists?

##

Considering the project you work on the most, please rate your agreement with the following statements. [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- Software developers are aware of potential security issues
- Software developers have expertise in software security
- Detection tools are used to find software vulnerabilities
- Checklists are used to find software vulnerabilites
- Code review is used to find software vulnerabilities
- Third-party libraries are checked for security issues
- Security documentation and training are available
- Enough time is available to consider security aspects

##

Considering the project you work on the most, rate how effective, in your opinion, the following measures would be in reducing the number of vulnerabilities. [*Not at all effective/Slightly effective/Somewhat effective/Very effective/Extremely effective/I don't know/Not Applicable*]:
- Increasing awareness of potential security issues
- Increasing the use of code review to find software vulnerabilities
- Writing more and better tests
- Having access to security vulnerability checklists
- Having more and better security documentation and training
- Reinforcing the security check of third-party libraries
- Having people responsible for security in the project/company
- Increasing the use of tools to identify security bugs
- Learning from past vulnerabilities that affected the project
- Having more time to consider security aspects

##

- Would there be any other useful solutions to reduce the number of vulnerabilities in the project you work on the most?
---
#### Demographic Questions
- (**1**) What is your gender?

- (**2**) What is your highest achieved level of education?
     - High School but did not graduate
     - High School graduate or GED
     - Some college or 2-year degree
     - Bachelor in CS (Computer Science)
     - Bachelor in STEM (Science, Technology, Engineering, and Mathematics)
     - Bachelor in a different area than CS or STEM
     - Master in CS
     - Master in STEM
     - Master in a different area than CS or STEM
     - Ph.D. or higher academic title in CS
     - Ph.D. or higher academic title in STEM
     - Ph.D. or higher academic title in a different area than CS or STEM

- (**3**) What's your current employment status?
     - Student (**4.1**)
     - Intern (**4.1**)
     - Part-time position (**4.2**)
     - Full-time position (**4.2**)
     - Unemployed

- (**4.1**) Are you currently enrolled in a degree-granting program?
     - Yes
     - No

- (**4.2**) What is your current position related to?
     - Software developer
     - Penetration tester
     - Bug bounty hunter
     - Software architect
     - IT operations
     - Project manager
     - Researcher / Professor
     - PhD student
     - Other

- (**4.2**) How many employees does your company have?
     - 1 employee
     - 2-10 employees
     - 11-19 employees
     - 20-50 employees
     - 51-100 employees
     - 100-200 employees
     - Over 200 employees

- (**4.2**) How big is your immediate team?
     - 1 person
     - 2-5 people
     - 6-10 people
     - 11-20 people
     - 21-50 people
     - Over 50 people

- Do you contribute to open-source software systems as one of your main programming activities?
     - Yes
     - No

- Please specify for how many years you have performed the following activities [*None/1 year or less/2 years/3-5 years/6-10 years/11 years or more*]:
     - Developed software in a professional setting (e.g., as employee of an IT-company or Open-Source contributor)
     - Programmed in Java (also not professionally)
     - Reviewed code
     - Worked with web applications
     - Worked with applications using databases

- Please specify how often you have performed the following activities in the last year:  [*Not at all/About once/About once a month/About once a week/Daily or more often*]:
     - Designed code
     - Developed code
     - Reviewed code
---
#### Final Feedback

- If you have any comments on the experiment, please add them here:

- All your data is anonymous! We will analyze it. May we also share it in a public research dataset?
     - Yes
     - No

- If you would like to receive the results of this study, please leave your email here. Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.

- If you would like to be interviewed in the context of this study, please leave your email here.
Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.
----
## Long Checklist

#### Index
- Donation on your behalf. As mentioned above, to thank you for your participation in the experiment, we are going to donate 5 USD (or its equivalent) to a non-profit organization on your behalf. The donation is made only on behalf of participants whose experiment is valid and complete. The donation will be done at the end of the entire study and will be announced from this Twitter Account. Please select the organization you prefer:
     - Wikimedia Foundation
     - Mozilla Foundation
     - Free Software Foundation
     - University Hospital Zurich Foundation
     - Other(*)
- Data handling policy
     - I agree with the data handling policy
---
#### Experiment
- You have X unfilled checklist items. You have not added any review comment yet. Do you want to complete the review anyway?
     - No
     - Yes
- How long have you been interrupted during the execution of the review?
     - No interruption time
     - 1-2 minutes
     - up to 5 minutes
     - up to 10 minutes
     - more than 10 minutes
---
#### Checklist Items
[*Yes/No/Irrelevant*]
- Input Handling
     - Is user-supplied input properly validated, sanitized, and filtered?
     - Is untrusted input data constrained for type, length, format, and range?

- Authentication
     - Are minimum and maximum password lengths enforced?
     - Is the set of allowed characters for passwords limited?
     - Are passwords hidden from the user, administrator, or system?
     - Does the password expire over time?
     - Does the session ID length have a minimum of 128 bits (16 bytes)?
     - Are session IDs generated uniquely and provide at least 64 bits of entropy?
     - Is all session data validated?
     - Are session IDs of newly generated sessions issued to a user only after successful authentication?
     - Does session destruction after logging out or timeout happen on both the server and browser?
     - Do session cookies have a short expiration time?
     - Are non-persistent cookies used for session management purposes?
     - Are authentication cookies encrypted?

- Data Protection
     - Are connection attempts logged?
     - Is sensitive data logged in a masked, sanitized, hashed, or encrypted state?
     - Is all data in-transit encrypted with secure protocols (e.g., TLS)?
     - Are up-to-date and appropriately strong standard encryption algorithms, protocols and keys used?
     - Are passwords stored in an encrypted format?
     - Are keys hardcoded into the source code?
     - Are encrypted keys and data stored on separate systems?
     - Is data outputted by the application correctly encoded?
---
#### Experiment Conclusion
- (**1**) Did you find the Sensitive Information Leakage vulnerability?
     - Yes (**1.1**)
     - No (**1.2**)

- (**1.1**) Did the checklist help you in identifying the Sensitive Information Leakage vulnerability?
     - Yes (**1.1.1**)
     - No (**1.1.2**)

- (**1.2**) Why do you think you did you miss the Sensitive Information Leakage vulnerability, and why did the checklist not help in finding it?

- (**1.1.1**) Can you explain how the checklist helped you in identifying the Sensitive Information Leakage vulnerability?

- (**1.1.2**) Can you explain why the checklist did not help you identifying the Sensitive Information Leakage vulnerability?

- (**2**) Did you find the MD5 cryptographic hash algorithm vulnerability?
     - Yes (**2.1**)
     - No (**2.2**)

- (**2.1**) Did the checklist help you in identifying the MD5 cryptographic hash algorithm vulnerability?
     - Yes (**2.1.1**)
     - No (**2.1.2**)

- (**2.2**) Why do you think you did miss the MD5 cryptographic hash algorithm vulnerability, and why did the checklist not help in finding it?

- (**2.1.1**) Can you explain how the checklist helped you in identifying the MD5 cryptographic hash algorithm vulnerability?

- (**2.1.2**) Can you explain why the checklist did not help you identifying the MD5 cryptographic hash algorithm vulnerability?

- The checklist was...
     - ...too short.
     - ...just right in length.
     - ...too long.

- The checklist was...
     - ...too specific.
     - ...just the right amount of detail.
     - ...too general.

- The checklist was...
     - ...easy to use.
     - ...neither easy nor complicated to use.
     - ...complicated to use.

- Can you explain why you did not fill in all checklist items?
---
#### Survey
Please choose an option for the following statements: [*No/Yes*]:
- I am familiar with the concept of software vulnerabilities
- I have experience with security incidents
- I have participated in security courses and/or training
- I use what I have learned in practice

##

- What kind of security courses and/or training have you participated in? Please check all that apply.
     - Lectures
     - Conference
     - Seminar
     - Hands-on course
     - Professional training

##

- What was your role in the security incidents you have experienced? Please check all that apply.
     - I introduced the vulnerability
     - I found the vulnerability
     - I fixed the vulnerability
     - I exploited the vulnerability

##

Specify your agreement with the following statements: [*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I keep myself up to date with security information
- It is part of my job responsibility to look for vulnerabilities
- I actively consider vulnerabilities when designing software
- I actively consider vulnerabilities when coding
- I actively look for vulnerabilities when reviewing

##

- How often have you reported a vulnerability while code reviewing in the last year?
     - Never
     - About once
     - About once a month
     - About once a week
     - Daily or more often

##

- How much time per code review do you spend on average looking for vulnerabilities? (in percentage)

##

Please answer the following questions regarding checklists: [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- I prefer using checklists for code reviewing
- Checklists are mainly for inexperienced code reviewers
- Checklists improve my code review efficiency
- Checklists help in finding security issues

##

[*Never/Rarely/Occasionally/Moderate amount/A great deal/I don't know/Not Applicable*]:
- I have used checklists for code review before

##

- In what context have you already used Checklists?

##

Considering the project you work on the most, please rate your agreement with the following statements. [*Strongly Disagree/Disagree/Neutral/Agree/Strongly Agree/I don't know/Not Applicable*]:
- Software developers are aware of potential security issues
- Software developers have expertise in software security
- Detection tools are used to find software vulnerabilities
- Checklists are used to find software vulnerabilites
- Code review is used to find software vulnerabilities
- Third-party libraries are checked for security issues
- Security documentation and training are available
- Enough time is available to consider security aspects

##

Considering the project you work on the most, rate how effective, in your opinion, the following measures would be in reducing the number of vulnerabilities. [*Not at all effective/Slightly effective/Somewhat effective/Very effective/Extremely effective/I don't know/Not Applicable*]:
- Increasing awareness of potential security issues
- Increasing the use of code review to find software vulnerabilities
- Writing more and better tests
- Having access to security vulnerability checklists
- Having more and better security documentation and training
- Reinforcing the security check of third-party libraries
- Having people responsible for security in the project/company
- Increasing the use of tools to identify security bugs
- Learning from past vulnerabilities that affected the project
- Having more time to consider security aspects

##

- Would there be any other useful solutions to reduce the number of vulnerabilities in the project you work on the most?
---
#### Demographic Questions
- (**1**) What is your gender?

- (**2**) What is your highest achieved level of education?
     - High School but did not graduate
     - High School graduate or GED
     - Some college or 2-year degree
     - Bachelor in CS (Computer Science)
     - Bachelor in STEM (Science, Technology, Engineering, and Mathematics)
     - Bachelor in a different area than CS or STEM
     - Master in CS
     - Master in STEM
     - Master in a different area than CS or STEM
     - Ph.D. or higher academic title in CS
     - Ph.D. or higher academic title in STEM
     - Ph.D. or higher academic title in a different area than CS or STEM

- (**3**) What's your current employment status?
     - Student (**4.1**)
     - Intern (**4.1**)
     - Part-time position (**4.2**)
     - Full-time position (**4.2**)
     - Unemployed

- (**4.1**) Are you currently enrolled in a degree-granting program?
     - Yes
     - No

- (**4.2**) What is your current position related to?
     - Software developer
     - Penetration tester
     - Bug bounty hunter
     - Software architect
     - IT operations
     - Project manager
     - Researcher / Professor
     - PhD student
     - Other

- (**4.2**) How many employees does your company have?
     - 1 employee
     - 2-10 employees
     - 11-19 employees
     - 20-50 employees
     - 51-100 employees
     - 100-200 employees
     - Over 200 employees

- (**4.2**) How big is your immediate team?
     - 1 person
     - 2-5 people
     - 6-10 people
     - 11-20 people
     - 21-50 people
     - Over 50 people

- Do you contribute to open-source software systems as one of your main programming activities?
     - Yes
     - No

- Please specify for how many years you have performed the following activities [*None/1 year or less/2 years/3-5 years/6-10 years/11 years or more*]:
     - Developed software in a professional setting (e.g., as employee of an IT-company or Open-Source contributor)
     - Programmed in Java (also not professionally)
     - Reviewed code
     - Worked with web applications
     - Worked with applications using databases

- Please specify how often you have performed the following activities in the last year:  [*Not at all/About once/About once a month/About once a week/Daily or more often*]:
     - Designed code
     - Developed code
     - Reviewed code
---
#### Final Feedback

- If you have any comments on the experiment, please add them here:

- All your data is anonymous! We will analyze it. May we also share it in a public research dataset?
     - Yes
     - No

- If you would like to receive the results of this study, please leave your email here. Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.

- If you would like to be interviewed in the context of this study, please leave your email here.
Results are used anonymously. Your email will never be shared with anyone, and you will not receive any other emails other than the results of this study. After we email the study results to you, we will delete your email.